// Challenge 3, Jonas Dedden

#include <stdio.h>
#include <math.h>

double integrate(double a, double b, double t, double (*f)(double));

double testFunc1(double x){
    return cos(x*x)*(x*x*x+53)/(x*x*x*x*x+9*x*x)/log(x)*exp(x);
}

double testFunc2(double x){
    return tan(1/x)*x*x;
}

int main(){
    printf("Integral of cos(x^2)/x/log(x)*e^x from 3.466 to 15.250:\n");

    printf("t=10^(-8)\t Result = %.13f\n", integrate(3.466, 15.250, 1e-8, &testFunc1));
    printf("t=10^(-9)\t Result = %.13f\n", integrate(3.466, 15.250, 1e-9, &testFunc1));
    printf("t=10^(-10)\t Result = %.13f\n", integrate(3.466, 15.250, 1e-10, &testFunc1));
    printf("Mathematica\t Result = %.13f\n", 24.4823742392468);

    printf("\n");
    printf("Integral of tan(1/x)*x^2 from 2.5938 to 9.390:\n");

    printf("t=10^(-8)\t Result = %.13f\n", integrate(2.5938, 9.390, 1e-8, &testFunc2));
    printf("t=10^(-12)\t Result = %.13f\n", integrate(2.5938, 9.390, 1e-12, &testFunc2));
    printf("t=10^(-15)\t Result = %.13f\n", integrate(2.5938, 9.390, 1e-15, &testFunc2));
    printf("Mathematica\t Result = %.13f\n", 41.1604531319940);
    return 0;
}